if( WIN32 )
	FIND_PATH(D3D10_ROOT_DIR Include/d3d10.h
	  HINTS
	    ENV DXSDK_DIR
	  PATH_SUFFIXES  DxSDK_Jun2010
	)

	FIND_PATH(D3D10_INCLUDE_DIR d3d10.h 
	  HINTS
	  PATH_SUFFIXES Include
	  PATHS
	  ${D3D10_ROOT_DIR}
	)

	if( CMAKE_CL_64 )
		FIND_PATH(D3D10_LIBRARY_DIR d3d10.lib
		  HINTS
		  PATH_SUFFIXES Lib/x64
		  PATHS
		  ${D3D10_ROOT_DIR}
		)

		FIND_LIBRARY(D3D10_LIBRARY
		  NAMES d3d10.lib
		  HINTS
		  PATH_SUFFIXES Lib/x64
		  PATHS
		  ${D3D10_LIBRARY_DIR}
		)

		FIND_LIBRARY(D3D10_X_LIBRARY
		  NAMES d3dx10.lib
		  HINTS
		  PATH_SUFFIXES Lib/x64
		  PATHS
		  ${D3D10_LIBRARY_DIR}
		)

		FIND_LIBRARY(D3D10_DXGI_LIBRARY
		  NAMES dxgi.lib
		  HINTS
		  PATH_SUFFIXES Lib/x64
		  PATHS
		  ${D3D10_LIBRARY_DIR}
		)
	else()
		FIND_PATH(D3D10_LIBRARY_DIR d3d10.lib
		  HINTS
		  PATH_SUFFIXES Lib/x86
		  PATHS
		  ${D3D10_ROOT_DIR}
		)

		FIND_LIBRARY(D3D10_LIBRARY
		  NAMES d3d10.lib
		  HINTS
		  PATH_SUFFIXES Lib/x86
		  PATHS
		  ${D3D10_LIBRARY_DIR}
		)

		FIND_LIBRARY(D3D10_X_LIBRARY
		  NAMES d3dx10.lib
		  HINTS
		  PATH_SUFFIXES Lib/x86
		  PATHS
		  ${D3D10_LIBRARY_DIR}
		)

		FIND_LIBRARY(D3D10_DXGI_LIBRARY
		  NAMES dxgi.lib
		  HINTS
		  PATH_SUFFIXES Lib/x86
		  PATHS
		  ${D3D10_LIBRARY_DIR}
		)
	endif()

	MARK_AS_ADVANCED( D3D10_LIBRARY_DIR D3D10_LIBRARY D3D10_X_LIBRARY D3D10_DXGI_LIBRARY )
	find_package_handle_standard_args( Direct3D10 DEFAULT_MSG D3D10_X_LIBRARY D3D10_DXGI_LIBRARY D3D10_LIBRARY D3D10_INCLUDE_DIR )
	if ( DIRECT3D10_FOUND )
		set( D3D10_LIBRARIES ${D3D10_LIBRARY} ${D3D10_X_LIBRARY} ${D3D10_DXGI_LIBRARY} CACHE STRING "Direct3D10 libraries" )
	endif()
endif()