/*!
 *\~english
 *\mainpage CastorUtils Library
 *\section intro_sec Introduction
 *This library contains some helper classes to ease the development of Castor3D engine.<br>
 *\section summary_sec Summary
 *Contains useful classes to manage mathematics :
 *<ul>
 *<li>Point</li>
 *<li>SphericalVertex</li>
 *<li>Matrix</li>
 *<li>Quaternion</li>
 *<li>Line (2D and 3D) equations</li>
 *<li>Plane equations</li>
 *<li>Angle conversions</li>
 *<li>Template math functions (such as exp, ln, ...)</li>
 *<li>Rectangles</li>
 *</ul>
 *Contains classes to manage Resources :
 *<ul>
 *<li>Resource</li>
 *<li>Pixel and PixelBuffer</li>
 *<li>Colour</li>
 *<li>Image</li>
 *<li>Font</li>
 *</ul>
 *Contains classes implementing concepts :
 *<ul>
 *<li>AutoSingleton</li>
 *<li>Unique</li>
 *<li>NonCopyable</li>
 *<li>Named</li>
 *<li>Loader</li>
 *<li>Container</li>
 *<li>Factory</li>
 *</ul>
 *Contains other useful classes :
 *<ul>
 *<li>Loader, BinaryLoader, TextLoader</li>
 *<li>File</li>
 *<li>FileParser</li>
 *<li>Assertion</li>
 *<li>Exception</li>
 *<li>DynamicLibrary</li>
 *<li>list, set, map, multimap and vector helper classes</li>
 *<li>Logger</li>
 *<li>MemoryManager to check memory leaks</li>
 *<li>Str and Path</li>
 *</ul>
 *\section install_sec Installation
 *\subsection step1 Step 1 : Downloading the source
 *The project sources are available <a href="http://projets.developpez.com/attachments/download/736/Castor.zip">here</a> or on Developpez.com SVN server : http://subversion.developpez.com/projets/Castor3D<br>
 *\subsection step2 Step 2 : Compilation
 *When sources are downloaded, you must use CMake (available <a href="http://www.cmake.org/cmake/resources/software.html">here</a>) to generate the project file most suitable to your system (Makefile, Code::Blocks, Visual Studio, ...)<br>
 *You'll need additional libraries :<br>
 *<ul>
 *<li>FreeImage</li>
 *<li>FreeType 2</li>
 *<li>boost::thread</li>
 *</ul>
 *Once you downloaded, compiled and installed the dependencies, you can compile CastorUtils.
 *\~french
 *\mainpage Bibliothèque CastorUtils
 *\section intro_sec Introduction
 *Cette bibliothèque contient des classes générales aidant au développement du moteur Castor3D<br>
 *\section summary_sec Résumé
 *Contient des classes utiles pour les mathématiques :
 *<ul>
 *<li>Point</li>
 *<li>SphericalVertex</li>
 *<li>Matrix</li>
 *<li>Quaternion</li>
 *<li>Equations de lignes (2D et 3D)</li>
 *<li>Equations de plan</li>
 *<li>Conversions d'angles</li>
 *<li>Fonction mathématiques template (telles que exp, ln, ...)</li>
 *<li>Rectangles</li>
 *</ul>
 *Contient des classe de gestion de ressources :
 *<ul>
 *<li>Resource</li>
 *<li>Pixel et PixelBuffer</li>
 *<li>Colour</li>
 *<li>Image</li>
 *<li>Font</li>
 *</ul>
 *Contient des classe implémentant des concepts :
 *<ul>
 *<li>AutoSingleton</li>
 *<li>Unique</li>
 *<li>NonCopyable</li>
 *<li>Named</li>
 *<li>Loader</li>
 *<li>Container</li>
 *<li>Factory</li>
 *</ul>
 *Et d'autres classes... :
 *<ul>
 *<li>Loader, BinaryLoader, TextLoader</li>
 *<li>File</li>
 *<li>FileParser</li>
 *<li>Assertion</li>
 *<li>Exception</li>
 *<li>DynamicLibrary</li>
 *<li>list, set, map, multimap et vector</li>
 *<li>Logger</li>
 *<li>MemoryManager pour vérifier les fuites de mémoire</li>
 *<li>Str et Path</li>
 *</ul>
 *\section install_sec Installation
 *\subsection step1 1ère étape : Téléchargement des sources
 *Les sources sont disponibles <a href="http://projets.developpez.com/attachments/download/736/Castor.zip">ici</a> ou accessibles via SVN, sur le serveur de Développez.com : http://subversion.developpez.com/projets/Castor3D<br>
 *\subsection step2 2ème étape : Compilation
 *Une fois les sources téléchargées, vous devez utiliser CMake (disponible <a href="http://www.cmake.org/cmake/resources/software.html">ici</a>) pour générer le type de projet qui vous conviendra (Makefile, Code::Blocks, Visual Studio, ...)<br>
 *Vous remarquerez que vous avez besoin de bibliothèques supplémentaires :<br>
 *<ul>
 *<li>FreeImage</li>
 *<li>FreeType 2</li>
 *<li>boost::thread</li>
 *</ul>
 *Une fois les dépendances téléchargées, compilées et installées, vous n'avez plus qu'à compiler CastorUtils
 */
