/*
This source file is part of Castor3D (http://castor3d.developpez.com/castor3d.htm)

This program is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the Free Software
Foundation; either version 2 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along with
the program; if not, write to the Free Software Foundation, Inc., 59 Temple
Place - Suite 330, Boston, MA 02111-1307, USA, or go to
http://www.gnu.org/copyleft/lesser.txt.
*/
#ifndef ___DX10_VERTEX_SHADER_H___
#define ___DX10_VERTEX_SHADER_H___

#include "Dx10ShaderObject.hpp"

namespace Dx10Render
{
	//! Class holding Vertex Shader
	class DxVertexShader
		:	public DxShaderObject
	{
	private:
		ID3D10VertexShader * m_pVertexShader;

	public:
		/**
		 * Constructor
		 */
		DxVertexShader( DxShaderProgram * p_pParent );
		/**
		 * Destructor
		 */
		virtual ~DxVertexShader();
		/**
		 *\~english
		 *\brief		Activates the shader
		 *\~french
		 *\brief		Active le shader
		 */
		virtual void Bind();
		/**
		 *\~english
		 *\brief		Deactivates the shader
		 *\~french
		 *\brief		Dsactive le shader
		 */
		virtual void Unbind();

	private:
		void DoRetrieveShader();
	};
}

#endif